function [X,L1,L2,dXdm] = assign(m,Xmin,Xmax)

A = 2*(Xmax-Xmin); 

if m<0
    X       = Xmin;
    dXdm    = 0;
    L1      = m^2;
    L2      = 0;
elseif m>=0 && m<1/2
    X       = A*m^2 + Xmin;
    dXdm    = 2*A*m;
    L1      = 0;
    L2      = 0;
elseif m>=1/2 && m<1
    X       = -A*(m-1)^2 + Xmax;
    dXdm    = -2*A*(m-1);
    L1      = 0;
    L2      = 0;
else
    X       = Xmax;
    dXdm    = 0;
    L1      = 0;
    L2      = (m-1)^2;
end