function [obj,flow] = F_2D(X,Y,c,param,glob,flowonly) 

a1              = param.a1;
a2              = param.a2;
h1              = param.h1;
h2              = param.h2;
d               = param.d;
%__________________________________________________________________________
flow            = a1*(X-h1).^2 + a2*(Y-h2).^2 + param.c*X.*Y + d;
if nargout==6
    obj         = [];
    return
end
%__________________________________________________________________________
stop            = 3;
[B0_X,~,~]      = SM_splibas(glob.xgrid0,X,glob.D1_X,glob.D2_X,stop);    
[B0_Y,~,~]      = SM_splibas(glob.ygrid0,Y,glob.D1_Y,glob.D2_Y,stop);    
continuation    = dprod(B0_Y,B0_X)*c;   
%__________________________________________________________________________
obj             = flow + continuation;

end